"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("core-js/modules/es.promise.js");
require("core-js/modules/es.json.stringify.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _workflow = _interopRequireDefault(require("../DataModals/workflow.json"));
var _fetchResponseHandler = _interopRequireDefault(require("../helpers/fetchResponseHandler"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
const CreateProcessInstance = async function CreateProcessInstance(props) {
  let dataModal = _objectSpread({}, _workflow.default);
  let {
    applicationReference,
    snapshotId,
    applicationStatus,
    processDefinition,
    firstTaskDetails,
    API_URL,
    headers
  } = props;
  dataModal.applicationReference = applicationReference;
  dataModal.applicationStatus = applicationStatus;
  dataModal.snapshotId = snapshotId;
  dataModal.processDefinition = processDefinition;
  dataModal.firstTaskDetails = firstTaskDetails;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/process");
  try {
    let response = await fetch(requestUrl, {
      method: "POST",
      body: JSON.stringify(dataModal),
      headers: _objectSpread(_objectSpread({}, headers), {}, {
        "Content-Type": "application/json"
      })
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const UpdateProcessInstanceStatus = async function UpdateProcessInstanceStatus(props) {
  let {
    statusUpdateRequest,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/process/status");
  try {
    let response = await fetch(requestUrl, {
      method: "PUT",
      body: JSON.stringify({
        statusUpdateRequest: statusUpdateRequest
      }),
      headers: _objectSpread(_objectSpread({}, headers), {}, {
        "Content-Type": "application/json"
      })
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const GetProcessInstance = async function GetProcessInstance(props) {
  let {
    payload,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/process/search");
  try {
    let response = await fetch(requestUrl, {
      method: "POST",
      headers: _objectSpread({}, headers),
      body: JSON.stringify(payload)
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const GetProcessInstanceComment = async function GetProcessInstanceComment(props) {
  let {
    comment,
    instanceId,
    page,
    size,
    API_URL,
    headers
  } = props;
  let query = "page=".concat(page, "&size=").concat(size);
  if (comment) query += "&comment= ".concat(comment);
  if (instanceId) query += "&instanceId= ".concat(instanceId);
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/process/comment?").concat(query);
  try {
    let response = await fetch(requestUrl, {
      method: "GET",
      headers: _objectSpread({}, headers)
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const AddProcessInstanceComment = async function AddProcessInstanceComment(props) {
  let {
    comment,
    instanceId,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/process/comment");
  try {
    let response = await fetch(requestUrl, {
      method: "POST",
      headers: _objectSpread({}, headers),
      body: JSON.stringify({
        comment: comment,
        instanceId: instanceId
      })
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const GetProcessInstanceByFilters = async function GetProcessInstanceByFilters(props) {
  let {
    page,
    size,
    keys,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/process/search/process-filters");
  try {
    let response = await fetch(requestUrl, {
      method: "POST",
      headers: _objectSpread({}, headers),
      body: JSON.stringify(_objectSpread({
        page: page,
        size: size
      }, keys))
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const DeleteAllProcessInstance = async function DeleteAllProcessInstance(props) {
  let {
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/process");
  try {
    let response = await fetch(requestUrl, {
      method: "DELETE",
      headers: _objectSpread({}, headers)
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const DeleteProcessInstanceById = async function DeleteProcessInstanceById(props) {
  let {
    instanceId,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/process/").concat(instanceId);
  try {
    let response = await fetch(requestUrl, {
      method: "DELETE",
      headers: _objectSpread({}, headers)
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
var _default = {
  CreateProcessInstance,
  UpdateProcessInstanceStatus,
  GetProcessInstance,
  GetProcessInstanceComment,
  AddProcessInstanceComment,
  GetProcessInstanceByFilters,
  DeleteAllProcessInstance,
  DeleteProcessInstanceById
};
exports.default = _default;