"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("core-js/modules/es.promise.js");
require("core-js/modules/es.json.stringify.js");
var _task = _interopRequireDefault(require("../DataModals/task.json"));
var _fetchResponseHandler = _interopRequireDefault(require("../helpers/fetchResponseHandler"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
const GetProcessTasks = async function GetProcessTasks(props) {
  let {
    instanceId,
    taskId,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/tasks/").concat(instanceId, "/").concat(taskId);
  try {
    let response = await fetch(requestUrl, {
      method: "GET",
      headers: _objectSpread({}, headers)
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const ClaimTask = async function ClaimTask(props) {
  let {
    userName,
    instanceId,
    taskId,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/tasks/claim");
  try {
    let response = await fetch(requestUrl, {
      method: "PUT",
      headers: _objectSpread({}, headers),
      body: JSON.stringify({
        action: "CLAIM",
        instanceId: instanceId,
        taskId: taskId,
        userName: userName
      })
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const ManageTask = async function ManageTask(props) {
  let dataModal = _objectSpread({}, _task.default);
  let {
    applicationStatus,
    applicationData,
    currentTask,
    instanceId,
    newTask,
    taskAction,
    processFilters,
    API_URL,
    headers
  } = props;
  dataModal.applicationStatus = applicationStatus;
  dataModal.applicationData = applicationData;
  dataModal.currentTask = currentTask;
  dataModal.instanceId = instanceId;
  dataModal.newTask = newTask;
  dataModal.taskAction = taskAction;
  dataModal.processFilters = processFilters;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/tasks/manage");
  try {
    let response = await fetch(requestUrl, {
      method: "PUT",
      headers: _objectSpread({}, headers),
      body: JSON.stringify(dataModal)
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const ReassignTask = async function ReassignTask(props) {
  let {
    requests,
    instanceId,
    updatedBy,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/tasks/reassign");
  try {
    let response = await fetch(requestUrl, {
      method: "PUT",
      headers: _objectSpread({}, headers),
      body: JSON.stringify({
        instanceId: instanceId,
        requests: requests,
        updatedBy: updatedBy
      })
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const SearchProcessTasks = async function SearchProcessTasks(props) {
  let {
    payload,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/tasks/search");
  try {
    let response = await fetch(requestUrl, {
      method: "POST",
      headers: _objectSpread({}, headers),
      body: JSON.stringify(payload)
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
const GetProcessTaskVariable = async function GetProcessTaskVariable(props) {
  let {
    instanceId,
    taskId,
    variableName,
    API_URL,
    headers
  } = props;
  let requestUrl = "".concat(API_URL, "/digital-bpm/workflow-engine/v1/tasks/variable/").concat(instanceId, "/").concat(taskId, "/").concat(variableName);
  try {
    let response = await fetch(requestUrl, {
      method: "GET",
      headers: _objectSpread({}, headers)
    });
    let result = await (0, _fetchResponseHandler.default)(response);
    return result;
  } catch (e) {
    throw e;
  }
};
var _default = {
  GetProcessTasks,
  ClaimTask,
  ManageTask,
  ReassignTask,
  SearchProcessTasks,
  GetProcessTaskVariable
};
exports.default = _default;